Unit SzovegHalmaz_Unit_Keret;
{
  TElem (most) String :a szovegek halmaznak tipusa:
  * UresHalmaz: ltrehoz egy halmazt, amelynek nulla db eleme van
  * Halmazba : a halmazhoz hozz ad egy elemet, 
  * ha nem tehet bele,  akkor hibsllapotba kerl
  * Halmazbol : a halmazbl elvesz egy adott elemet
  * ElemeE : eldnti, hogy egy adott elemet tartalmaz-e a halmaz 
  * Halmazbeolvas : egy halmazba beolvas elemeket billentyuzetrol 
  * Halmazbeolvas_fajlbol : egy halmazba beolvas elemeket szvegfjlbl 
  * HalmazKiir : egy halmaz elemeit soronknt kiirja a kpernyore
  * HibasE : hibs llapotban van-e a halmaz
  * Elemszam : megadja, hogy hny eleme van a halmaznak
  * MaxElemszam : megadja, hogy maximlisan hny eleme lehet egy halmaznak
  brzols:
  * A halmazt lnyegben egy TElem tipusu elemekbl ll tmb fogja tartalmazni.
    A ksbbi "kellemes" kezels kedvrt kiegszitjk egy darabszmot s egy 
    hibsllapotot tartalmaz mezvel.
}

Interface

  Const
    MaxElemszam=3;
    // MaxElemszam=40;
  Type
    //az elem tipusa:
    TElem=String;
    //a halmaz tipusa:
    THalmaz=Record
              db:Integer;
              elem:Array [1..MaxElemszam] of TElem;
              hiba:Boolean;
            End;
  Const UresHalmaz:THalmaz=(db:0;
                      elem:('','','');
                      //elem:('','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
                      hiba:False);

  Operator in(Const e:TElem;Const h:THalmaz)l:Boolean;
  Procedure Halmazba(Var h:THalmaz; Const e:TElem);
  Procedure Halmazbol(Var h:THalmaz; Const e:TElem);
  Function  Elemszam(Const h:THalmaz):Integer;
  Procedure Halmazbeolvas(Const kerd:String; Var h:THalmaz);
  Procedure Halmazbeolvas_fajlbol(Var h:THalmaz);
  Procedure HalmazKiir(Const elo:String; Const h:THalmaz; Const uto:String);
  Function  HibasE(Var h:THalmaz):Boolean;

Implementation

 Operator in(Const e:TElem;Const h:THalmaz)l:Boolean;
    Var
      i:Integer;
  Begin
  End;

  Procedure Halmazba(Var h:THalmaz; Const e:TElem);
  Begin
  End;

  Procedure Halmazbol(Var h:THalmaz; Const e:TElem);
    Var
      i:Integer;
  Begin
  End;

  Function Elemszam(Const h:THalmaz):Integer;
  Begin
  End;
 
  Procedure Halmazbeolvas(Const kerd:String; Var h:THalmaz);
    Var
      i,db:Integer;
      e:TElem;
  Begin
    Writeln; Writeln(kerd);
    h:=UresHalmaz;
    Write('Elemszm:'); {$i-}Readln(db);{$i+}
    If (IOResult=0) and(db>=0) and (db<=MaxElemszam) then
    Begin
      For i:=1 to db do
      Begin
        Write(i:3,'.:'); Readln(e);
        Halmazba(h,e);//megengedjk ugyanazt az elemet tbbszr is, de csak egyszer kerl be!
      End;
      h.hiba:=False;
    End
      else
    Begin
      h.hiba:=True
    End;
  End;

Procedure Halmazbeolvas_fajlbol(Var h:THalmaz);
	Function OlvasasraNyit(Var f:Text; Const fN:String):Boolean;
		Begin
			Assign(f,fN); 
			{$i-} Reset(f); {$i+}
			OlvasasraNyit:=IOResult=0
		End;{OlvasasraNyit}
 Var
	  f:Text;
      fN:String;
      siker:Boolean;
      e:TElem;
Begin
    Repeat
      Write('A fajl neve:'); Readln(fN);
      siker:=OlvasasraNyit(f,fN);
      If not siker then Writeln('Hibas fajlnev, kerem ujra!');
    Until siker;	
    h:=UresHalmaz; 
    While not eof(f)  and (not h.hiba) do
     Begin
		Readln(f,e); 
        Halmazba(h,e);//megengedjk ugyanazt az elemet tbbszr is, de csak egyszer kerl be!
     End;
     Close(f);
End;     


  Procedure HalmazKiir(Const elo:String; Const h:THalmaz; Const uto:String);
    Const
      Bool2Str: Array [Boolean] of String[4]=('Nem','Igen');
    Var
      i:Integer;
  Begin
    Writeln(elo);
    Writeln('Elemek szma:',h.db);
    For i:=1 to h.db do
    Begin
      Writeln(i:3,'.: "',h.elem[i],'"');
    End;
    Writeln('Hibs-e:',Bool2Str[h.hiba]);
    Writeln(uto);
  End;

  Function HibasE(Var h:THalmaz):Boolean;
  Begin
    HibasE:=h.hiba; h.hiba:=False
  End;

Begin
End.
